﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace OpenQuarters.WebQuarters.Core
{
    public interface IItemListable
    {
        IQueryable GetQueryableList();
        string GetIDAsString();
        IItemListable GetItemFromUrl(string url, List<IItemListable> additionalItems);
        bool IsNewItem();
        IItemListable CreateItem<T>(ItemListerControl<T> parentList) where T : class, IItemListable;
        IItemListable LoadItem(string id);
        IItemListable SaveItem();
        RssToolkit.Rss.RssItem ToRssItem();
        void DeleteItem();
        string ItemTitle();
        string ItemUrl();
        string MetaKeywords();
        string MetaDescription();
    }
}
