﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;

namespace OpenQuarters.WebQuarters.Core
{
    public class SettingsElementCollection : ConfigurationElementCollection
    {
        public SettingsElement this[int index]
        {
            get
            {
                return base.BaseGet(index) as SettingsElement;
            }
            set
            {
                if (base.BaseGet(index) != null)
                {
                    base.BaseRemoveAt(index);
                }
                this.BaseAdd(index, value);
            }
        }

        public SettingsElement this[string name]
        {
            get
            {
                return base.BaseGet(name) as SettingsElement;
            }
        }

        protected override ConfigurationElement CreateNewElement()
        {
            return new SettingsElement();
        }

        protected override object GetElementKey(ConfigurationElement element)
        {
            return ((SettingsElement)element).Name;
        } 
    }
}
