﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;
using System.Web;
using System.Web.Configuration;
using System.Net.Configuration;

namespace OpenQuarters.WebQuarters.Utils
{
    public class Email
    {
        public static void Send(string to, string from, string cc, string bcc,string subject, string body, bool isHtml)
        {
            Configuration config = WebConfigurationManager.OpenWebConfiguration(HttpContext.Current.Request.ApplicationPath);
            MailSettingsSectionGroup settings = (MailSettingsSectionGroup)config.GetSectionGroup("system.net/mailSettings");
 
            // Create the mail message.
            System.Web.Mail.MailMessage mailMessage = new System.Web.Mail.MailMessage();
            mailMessage.From = from;
            mailMessage.To = to;
            mailMessage.Cc = cc;
            mailMessage.Bcc = bcc;
            mailMessage.Subject = subject;
            mailMessage.Body = body;
            if (isHtml)
                mailMessage.BodyFormat = System.Web.Mail.MailFormat.Html;

            // Set authentication.
            mailMessage.Fields.Add("http://schemas.microsoft.com/cdo/configuration/smtpauthenticate", "1"); //Basic authentication.
            mailMessage.Fields.Add("http://schemas.microsoft.com/cdo/configuration/sendusername", settings.Smtp.Network.UserName);
            mailMessage.Fields.Add("http://schemas.microsoft.com/cdo/configuration/sendpassword", settings.Smtp.Network.Password);
            mailMessage.Fields.Add("http://schemas.microsoft.com/cdo/configuration/smtpserverport", settings.Smtp.Network.Port);

            System.Web.Mail.SmtpMail.SmtpServer = settings.Smtp.Network.Host;

            // Send the email.
            System.Web.Mail.SmtpMail.Send(mailMessage);
        }
    }
}
